import { system, Player, world } from "@minecraft/server";                                              // Made by Jayly
;
// Using map because typescript doesn't support prototype property declaration properly
const clicks = new Map();
world.afterEvents.entityHitBlock.subscribe(function ({ damagingEntity }) {
    if (!(damagingEntity instanceof Player))
        return;
    const clickInfo = { timestamp: Date.now() };
    const playerClicks = clicks.get(damagingEntity) || [];
    playerClicks.push(clickInfo);
    clicks.set(damagingEntity, playerClicks);
});
world.afterEvents.entityHitEntity.subscribe(function ({ damagingEntity }) {
    if (!(damagingEntity instanceof Player))
        return;
    const clickInfo = { timestamp: Date.now() };
    const playerClicks = clicks.get(damagingEntity) || [];
    playerClicks.push(clickInfo);
    clicks.set(damagingEntity, playerClicks);
});
/**
 * Get a player's clicks per second
 * @param player
 * @returns
 */
export function getPlayerCPS(player) {
    const currentTime = Date.now();
    const playerClicks = clicks.get(player) || [];
    const recentClicks = playerClicks.filter(({ timestamp }) => currentTime - 1000 < timestamp);
    clicks.set(player, recentClicks);
    return recentClicks.length;
};
system.runInterval(() => {                                                                            // This part I added
    const players = world.getAllPlayers();
    for (const player of players) {
        if (player.hasTag("cps")) {  
      player.onScreenDisplay.setActionBar(`CPS ${getPlayerCPS(player)}`);
    }
  } 
});

